/* ------------------------------------------------------------ */
/*
HTTrack Website Copier, Offline Browser for Windows and Unix
Copyright (C) Xavier Roche and other contributors

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Important notes:

- We hereby ask people using this source NOT to use it in purpose of grabbing
emails addresses, or collecting any other private information on persons.
This would disgrace our work, and spoil the many hours we spent on it.


Please visit our Website: http://www.httrack.com
*/


/* ------------------------------------------------------------ */
/* File: basic FTP protocol manager                             */
/* Author: Xavier Roche                                         */
/* ------------------------------------------------------------ */

// Gestion protocole ftp
// Version .05 (01/2000)

#include "htsftp.h"

#include "htsglobal.h"
#include "htsbase.h"
#include "htsnet.h"
#include "htsthread.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if HTS_WIN
#else
//inet_ntoa
#include <arpa/inet.h>
#endif

#if HTS_WIN
#ifndef __cplusplus
// DOS
#include <process.h>    /* _beginthread, _endthread */
#endif
#endif

// ftp mode passif
#define FTP_PASV 1

#define FTP_DEBUG 0
//#define FORK_DEBUG 0

#define FTP_STATUS_READY 1001

#if USE_BEGINTHREAD
/*
#ifdef __cplusplus
// C++ -> Shell
UINT back_launch_ftp( LPVOID pP ) {
  lien_back* back=(lien_back*) pP;
  if (back == NULL) {
    //back->status=FTP_STATUS_READY;    // fini
    //back->r.statuscode=-1;
    return -1;
  }
  
  // lancer ftp
  run_launch_ftp(back);
  // prt
  back->status=0;

  return 0;    // thread completed successfully
}
#else
*/
PTHREAD_TYPE back_launch_ftp( void* pP ) {
  lien_back* back=(lien_back*) pP;
  if (back == NULL) {
    //back->status=FTP_STATUS_READY;    // fini
    //back->r.statuscode=-1;
#if FTP_DEBUG
    printf("[ftp error: no args]\n");
#endif
    return PTHREAD_RETURN;
  }
  
  // lancer ftp
#if FTP_DEBUG
  printf("[Launching main ftp routine]\n");
#endif
  run_launch_ftp(back);
  // prt
  back->status=0;
  
  return PTHREAD_RETURN;
}
/*#endif*/
// lancer en back
void launch_ftp(lien_back* back) {
/*
#ifdef __cplusplus
  // C++ -> Shell
  AfxBeginThread(back_launch_ftp,(LPVOID) back);
#else
*/
  // DOS
#if FTP_DEBUG
  printf("[Launching main ftp thread]\n");
#endif
  _beginthread(back_launch_ftp, 0, (void*) back);
/*#endif*/
}

#else
// Unix sans pthread
int back_launch_ftp(lien_back* back) {
  // lancer ftp
  run_launch_ftp(back);
  // prt
  back->status=0;
  return 0;
}
void launch_ftp(lien_back* back,char* path,char* exec) {
  FILE* fp = fopen(fconv(path),"wb");
  if (fp) {
    char _args[8][256];
    char *args[8];
    fclose(fp); fp=NULL;
    
    strcpy(_args[0],exec);
    strcpy(_args[1],"-#R");
    strcpy(_args[2],back->url_adr);
    strcpy(_args[3],back->url_fil);
    strcpy(_args[4],back->url_sav);
    strcpy(_args[5],path);
    //strcpy(_args[6],"");
    args[0]=_args[0];
    args[1]=_args[1];
    args[2]=_args[2];
    args[3]=_args[3];
    args[4]=_args[4];
    args[5]=_args[5];
    args[6]=NULL;
    switch (fork()) {    // note: vfork dconne un max'
    case -1: printf("Can not vfork() process\n"); break;
    case 0: 
      if (execvp(args[0],args)==-1) {
        fp=fopen(fconv(path),"wb");
        if (fp) {
          fprintf(fp,"-1 unable to launch %s",args[0]);
          fclose(fp); fp=NULL;
          rename(path,concat(path,".ok"));
        } else remove(path);
      }
      _exit(0);    // exit 'propre'
      break;
    default:  // parent
      // bah on fait rien..
      break;         
    }
  }
}
#endif

// pour l'arrt du ftp
#ifdef _WIN32
#define _T_SOC_close(soc)  closesocket(soc); soc=INVALID_SOCKET;
#else
#define _T_SOC_close(soc)  close(soc); soc=INVALID_SOCKET;
#endif
#define _HALT_FTP { \
  if ( soc_ctl     != INVALID_SOCKET ) _T_SOC_close(soc_ctl); \
  if ( soc_servdat != INVALID_SOCKET ) _T_SOC_close(soc_servdat); \
  if ( soc_dat     != INVALID_SOCKET ) _T_SOC_close(soc_dat); \
}
#define _CHECK_HALT_FTP \
  if (stop_ftp(back)) { \
  _HALT_FTP \
  return 0; \
  }

// la vritable fonction une fois lances les routines thread/fork
int run_launch_ftp(lien_back* back) {
  char user[256]="anonymous";
  char pass[256]="user@";
  char line_retr[2048];
  int port=21;
  int port_pasv=0;
  char adr_ip[1024];
  char *adr,*real_adr;
  char* ftp_filename="";
  int timeout = 300;    // timeout
  int timeout_onfly=8;  // attente rponse supplmentaire
  int transfer_list=0;  // directory
  int rest_understood=0;  // rest command understood
  //
  T_SOC soc_ctl=INVALID_SOCKET;
  T_SOC soc_servdat=INVALID_SOCKET;
  T_SOC soc_dat=INVALID_SOCKET;
  //
  line_retr[0]=adr_ip[0]='\0';
  
  timeout=300;
  
  // effacer
  strcpy(back->r.msg,"");
  back->r.statuscode=0;
  back->r.size=0;
  
  // rcuprer user et pass si prsents, et sauter user:id@ dans adr
  real_adr = strchr(back->url_adr,':');
  if (real_adr) real_adr++;
  else real_adr=back->url_adr;
  while(*real_adr=='/') real_adr++;    // sauter /
  if ( (adr = jump_identification(real_adr)) != real_adr) {  // user
    int i=-1;
    pass[0]='\0';
    do {
      i++;
      user[i]=real_adr[i];
    } while( (real_adr[i]!=':') && (real_adr[i]) );
    user[i]='\0';
    if (real_adr[i]==':') {    // pass
      int j=-1;
      i++;  // oui on saute aussi le :
      do {
        j++;
        pass[j]=real_adr[i+j];
      } while( ((int) (&real_adr[i+j+1]) < (int) adr) && (real_adr[i+j]) );
      pass[j]='\0';
    }
  }
  
  // Calculer RETR <nom>
  {
    char* a;
    a=back->url_fil + strlen(back->url_fil)-1;
    while( ((int) a > (int) back->url_fil) && (*a!='/')) a--;
    if (*a == '/') {    // ok repr
      a++;    // sauter /
      ftp_filename=a;
      if (strnotempty(a))
        sprintf(line_retr,"RETR %s",a);
      else {
        transfer_list=1;
        sprintf(line_retr,"LIST -A");
      }
    } else {
      strcpy(back->r.msg,"Unexpected PORT error");
      back->status=FTP_STATUS_READY;    // fini
      back->r.statuscode=-1;
    }
  }
  
#if FTP_DEBUG
  printf("Connecting to %s...\n",adr);
#endif
  
  // connexion
  {
    struct sockaddr_in server;
    t_hostent* hp;    
    char * a;
    char _adr[256];
    _adr[0]='\0';
    //T_SOC soc_ctl;
    // effacer structure
    bzero((char *)&server, sizeof(server));
    
    // port
    a=strchr(adr,':');    // port
    if (a) {
      sscanf(a+1,"%d",&port);
      strncat(_adr,adr,(int) a - (int) adr);
    } else
      strcpy(_adr,adr);
    
    // rcuprer adresse rsolue
    strcpy(back->info,"host name");
    hp = hts_gethostbyname(_adr);
    if (hp == NULL) {
      strcpy(back->r.msg,"Unable to get server's address");
      back->status=FTP_STATUS_READY;    // fini
      back->r.statuscode=-5;
      _HALT_FTP
        return 0;
    }
    _CHECK_HALT_FTP;
    
    // copie adresse
    bcopy(hp->h_addr, (char *)&server.sin_addr, hp->h_length);
    
    // crer ("attachement") une socket (point d'accs) internet,en flot
    soc_ctl=socket(AF_INET,SOCK_STREAM,0);
    if (soc_ctl==INVALID_SOCKET) {
      strcpy(back->r.msg,"Unable to create a socket");
      back->status=FTP_STATUS_READY;    // fini
      back->r.statuscode=-1;
      _HALT_FTP
        return 0;
    }
    server.sin_family = AF_INET;
    server.sin_port = htons((unsigned short int) port);
    
    // connexion (bloquante, on est en thread)
    strcpy(back->info,"connect");

#if HTS_WIN
    if (connect(soc_ctl, (const struct sockaddr FAR *)&server, sizeof(server)) != 0) {
#else
      if (connect(soc_ctl, (struct sockaddr *)&server, sizeof(server)) == -1) {
#endif
        strcpy(back->r.msg,"Unable to connect to the server");
        back->status=FTP_STATUS_READY;    // fini
        back->r.statuscode=-1;
        _HALT_FTP
          return 0;
#if HTS_WIN
      }
#else
    }
#endif
    _CHECK_HALT_FTP;
    
    {
      char line[1024];
      // envoi du login
      
      // --USER--
      get_line(soc_ctl,line,timeout);    // en tte
      _CHECK_HALT_FTP;
      
      if (line[0]=='2') {        // ok, connect
        strcpy(back->info,"login: user");
        sprintf(line,"USER %s",user);
        send_line(soc_ctl,line);
        get_line(soc_ctl,line,timeout);
        _CHECK_HALT_FTP;	  
        if (line[0]=='3') {
          // --PASS--
          strcpy(back->info,"login: pass");
          sprintf(line,"PASS %s",pass);
          send_line(soc_ctl,line);
          get_line(soc_ctl,line,timeout);
          _CHECK_HALT_FTP;	  
          if (line[0]=='2') {  // ok
            // --CWD--
            char* a;
            a=back->url_fil + strlen(back->url_fil)-1;
            while( ((int) a > (int) back->url_fil) && (*a!='/')) a--;
            if (*a == '/') {    // ok repr
              char target[1024];
              target[0]='\0';
              strncat(target,back->url_fil,(int) a - (int) back->url_fil);
              if (strnotempty(target)==0)
                strcat(target,"/");
              strcpy(back->info,"cwd");
              sprintf(line,"CWD %s",target);
              send_line(soc_ctl,line);
              get_line(soc_ctl,line,timeout);
              _CHECK_HALT_FTP;	  
              if (line[0]=='2') {
                send_line(soc_ctl,"TYPE I");
                get_line(soc_ctl,line,timeout);
                _CHECK_HALT_FTP;	  
                if (line[0]=='2') {
                  // ok..
                } else {
                  strcpy(back->r.msg,"TYPE I error");
                  back->status=FTP_STATUS_READY;    // fini
                  back->r.statuscode=-1;
                }
              } else {
                sprintf(back->r.msg,"CWD error: %s",linejmp(line));
                back->status=FTP_STATUS_READY;    // fini
                back->r.statuscode=-1;
              }    // sinon on est prts
            } else {
              strcpy(back->r.msg,"Unexpected ftp error");
              back->status=FTP_STATUS_READY;    // fini
              back->r.statuscode=-1;
            }
            
          } else {
            sprintf(back->r.msg,"Bad password: %s",linejmp(line));
            back->status=FTP_STATUS_READY;    // fini
            back->r.statuscode=-1;
          }
        } else {
          sprintf(back->r.msg,"Bad user name: %s",linejmp(line));
          back->status=FTP_STATUS_READY;    // fini
          back->r.statuscode=-1;
        }
      } else {
        sprintf(back->r.msg,"Connection refused: %s",linejmp(line));
        back->status=FTP_STATUS_READY;    // fini
        back->r.statuscode=-1;
      }
     
      // ok, si on est prts on coute sur un port et on demande la sauce
      if (back->r.statuscode != -1) {

        
        //
        // Pr-REST
        //
#if FTP_PASV
        strcpy(back->info,"pasv");
        sprintf(line,"PASV");
        send_line(soc_ctl,line);
        get_line(soc_ctl,line,timeout);
        _CHECK_HALT_FTP;	  
        if (line[0]=='2') {
          char *a,*b,*c;
          a=strchr(line,'(');       // exemple: 227 Entering Passive Mode (123,45,67,89,177,27)
          if (a) {
           
            // -- analyse de l'adresse IP et du port --
            a++;
            b=strchr(a,',');
            if (b) b=strchr(b+1,',');
            if (b) b=strchr(b+1,',');
            if (b) b=strchr(b+1,',');
            c=a; while( (c=strchr(c,',')) ) *c='.';        // remplacer , par .
            if (b) *b='\0';
            //
            strcpy(adr_ip,a);       // copier adresse ip
            //
            if (b) {
              a=b+1;  // dbut du port
              b=strchr(a,'.');
              if (b) {
                int n1,n2;
                //
                *b='\0';
                b++;
                c=strchr(b,')');
                if (c) {
                  *c='\0';
                  //
                  if ( (sscanf(a,"%d",&n1)==1) && (sscanf(b,"%d",&n2)==1) && (strlen(adr_ip)<=16)) {
                    //
#ifndef HTS_LITTLE_ENDIAN
                    port_pasv=n2+(n1<<8);
#else
                    port_pasv=n1+(n2<<8);
#endif
                  }
                } else {
                  deletesoc(soc_dat); soc_dat=INVALID_SOCKET;
                }    // sinon on est prts
              }
            }
            // -- fin analyse de l'adresse IP et du port --
          } else {
            sprintf(back->r.msg,"PASV incorrect: %s",linejmp(line));
            back->status=FTP_STATUS_READY;    // fini
            back->r.statuscode=-1;
          }    // sinon on est prts
        } else {
          sprintf(back->r.msg,"PASV error: %s",linejmp(line));
          back->status=FTP_STATUS_READY;    // fini
          back->r.statuscode=-1;
        }    // sinon on est prts
#else
        // rien  faire avant
#endif

#if FTP_PASV
        if (port_pasv) {
#endif
          // REST lui mme
          if (back->r.statuscode != -1) {
            if (!transfer_list) {
              // SIZE?
              strcpy(back->info,"size");
              sprintf(line,"SIZE %s",ftp_filename);
              send_line(soc_ctl,line);
              get_line(soc_ctl,line,timeout);
              _CHECK_HALT_FTP;	  
              if (line[0]=='2') {  // SIZE compris, ALORS tester REST (sinon pas tester: cf probleme des txt.gz decompresses a la volee)
                // REST?
                if (fexist(back->url_sav) && (transfer_list==0)) {
                  strcpy(back->info,"rest");
                  sprintf(line,"REST "LLintP,(LLint)fsize(back->url_sav));
                  send_line(soc_ctl,line);
                  get_line(soc_ctl,line,timeout);
                  _CHECK_HALT_FTP;	  
                  if (line[0]=='3') {  // ok
                    rest_understood=1;
                  } // sinon tant pis 
                } 
              }  // sinon tant pis 
            }
          }
#if FTP_PASV
        }
#endif

        //
        // Post-REST
        //
#if FTP_PASV
        // Ok, se connecter
        if (port_pasv) {
          struct sockaddr_in server;
          t_hostent* hp;    
          // effacer structure
          bzero((char *)&server, sizeof(server));
          
          // infos
          strcpy(back->info,"resolv");
          
          // rsoudre
          hp = hts_gethostbyname(adr_ip);
          
          // infos
          strcpy(back->info,"cnxdata");
#if FTP_DEBUG
          printf("Data: Connecting to %s:%d...\n",adr_ip,port_pasv);
#endif
          if (hp) {
            // copie adresse
            bcopy(hp->h_addr, (char *)&server.sin_addr, hp->h_length);
            
            // socket
            soc_dat=socket(AF_INET,SOCK_STREAM,0);
            if (soc_dat != INVALID_SOCKET) {
              // structure: connexion au domaine internet, port 80 (ou autre)
              server.sin_family = AF_INET;
              server.sin_port = htons((unsigned short int) port_pasv);
#if HTS_WIN
              if (connect(soc_dat, (const struct sockaddr FAR *)&server, sizeof(server)) == 0) {
#else
              if (connect(soc_dat, (struct sockaddr *)&server, sizeof(server)) != -1) {
#endif
                strcpy(back->info,"retr");
                strcpy(line,line_retr);
                send_line(soc_ctl,line);
                get_line(soc_ctl,line,timeout);
                _CHECK_HALT_FTP;	  
                if (line[0]=='1') {
                  // OK
                } else {
                  deletesoc(soc_dat); soc_dat=INVALID_SOCKET;
                  //
                  sprintf(back->r.msg,"RETR command errror: %s",linejmp(line));
                  back->status=FTP_STATUS_READY;    // fini
                  back->r.statuscode=-1;
                }    // sinon on est prts
              } else {
                deletesoc(soc_dat); soc_dat=INVALID_SOCKET;
                //
                strcpy(back->r.msg,"Unable to connect");
                back->status=FTP_STATUS_READY;    // fini
                back->r.statuscode=-1;
              }    // sinon on est prts
            } else {
              strcpy(back->r.msg,"Unable to create a socket");
              back->status=FTP_STATUS_READY;    // fini
              back->r.statuscode=-1;
            }    // sinon on est prts
          } else {
            sprintf(back->r.msg,"Unable to resolve IP %s",adr_ip);
            back->status=FTP_STATUS_READY;    // fini
            back->r.statuscode=-1;
          }    // sinon on est prts
        } else {
          sprintf(back->r.msg,"PASV incorrect: %s",linejmp(line));
          back->status=FTP_STATUS_READY;    // fini
          back->r.statuscode=-1;
        }    // sinon on est prts
#else
        //T_SOC soc_servdat;
        strcpy(back->info,"listening");
        if ( (soc_servdat = get_datasocket(line)) != INVALID_SOCKET) {
          _CHECK_HALT_FTP;	  
          send_line(soc_ctl,line);          // envoi du RETR
          get_line(soc_ctl,line,timeout);
          _CHECK_HALT_FTP;	  
          if (line[0]=='2') {  // ok
            strcpy(back->info,"retr");
            strcpy(line,line_retr);
            send_line(soc_ctl,line);
            get_line(soc_ctl,line,timeout);
            _CHECK_HALT_FTP;	  
            if (line[0]=='1') {
              //T_SOC soc_dat;
              struct sockaddr dummyaddr;
              int dummylen = sizeof(struct sockaddr);
              if ( (soc_dat=accept(soc_servdat,&dummyaddr,&dummylen)) == INVALID_SOCKET) {
                strcpy(back->r.msg,"Unable to accept connection");
                back->status=FTP_STATUS_READY;    // fini
                back->r.statuscode=-1;
              }
            } else {
              sprintf(back->r.msg,"RETR command errror: %s",linejmp(line));
              back->status=FTP_STATUS_READY;    // fini
              back->r.statuscode=-1;
            }
          } else {
            sprintf(back->r.msg,"PORT command error: %s",linejmp(line));
            back->status=FTP_STATUS_READY;    // fini
            back->r.statuscode=-1;
          }
#if HTS_WIN
          closesocket(soc_servdat);
#else
          close(soc_servdat);
#endif
        } else {
          strcpy(back->r.msg,"Unable to listen to a port");
          back->status=FTP_STATUS_READY;    // fini
          back->r.statuscode=-1;
        }
#endif
        
        //
        // Ok, connexion initie
        //
        if (soc_dat != INVALID_SOCKET) {
          if (rest_understood) {         // REST envoye et comprise
            filenote(back->url_sav,NULL);
            back->r.fp = fopen(fconv(back->url_sav),"ab");
          } else
            back->r.fp = filecreate(back->url_sav);
          strcpy(back->info,"receiving");
          if (back->r.fp != NULL) {
            char buff[1024];
            int len=1;
            int read_len=1024;
            //HTS_TOTAL_RECV_CHECK(read_len);         // Diminuer au besoin si trop de donnes reues
            
            while( (len>0) && (!stop_ftp(back)) ) {
              // attendre les donnes
              len=1;    // pas d'erreur pour le moment
              switch(wait_socket_receive(soc_dat,timeout)) {
              case -1:
                strcpy(back->r.msg,"Read error");
                back->status=FTP_STATUS_READY;    // fini
                back->r.statuscode=-1;
                len=0;    // fin
                break;
              case 0:
                sprintf(back->r.msg,"Time out (%d)",timeout);
                back->status=FTP_STATUS_READY;    // fini
                back->r.statuscode=-1;
                len=0;    // fin
                break;
              }
              
              // rception
              if (len) {
                len=recv(soc_dat,buff,read_len,0);
                if (len>0) {
                  back->r.size+=len;
                  HTS_STAT.HTS_TOTAL_RECV+=len; 
                  if (back->r.fp) {
                    if ((int) fwrite(buff,1,len,back->r.fp) != len) {
                      strcpy(back->r.msg,"Write error");
                      back->status=FTP_STATUS_READY;    // fini
                      back->r.statuscode=-1;
                      len=0;  // error
                    }
                  } else {
                    strcpy(back->r.msg,"Unexpected write error");
                    back->status=FTP_STATUS_READY;    // fini
                    back->r.statuscode=-1;
                  }
                } else {        // Erreur ou termin
                  //strcpy(back->r.msg,"Read error");
                  back->status=FTP_STATUS_READY;    // fini
                  back->r.statuscode=0;
                }
                read_len=1024; 
                //HTS_TOTAL_RECV_CHECK(read_len);         // Diminuer au besoin si trop de donnes reues
              }
            }
            if (back->r.fp) { 
              fclose(back->r.fp); 
              back->r.fp=NULL;
            }
          } else {
            strcpy(back->r.msg,"Unable to write file");
            back->status=FTP_STATUS_READY;    // fini
            back->r.statuscode=-1;
          }
#if HTS_WIN
          closesocket(soc_dat);
#else
          close(soc_dat);
#endif
          
          // 226 Transfer complete?
          if (back->r.statuscode != -1) {
            if (wait_socket_receive(soc_ctl,timeout_onfly)>0) {
              // rcuprer 226 transfer complete
              get_line(soc_ctl,line,timeout);
              if (line[0]=='2') {       // OK
                strcpy(back->r.msg,"OK");
                back->status=FTP_STATUS_READY;    // fini
                back->r.statuscode=200;
              } else {
                sprintf(back->r.msg,"RETR incorrect: %s",linejmp(line));
                back->status=FTP_STATUS_READY;    // fini
                back->r.statuscode=-1;
              }
            } else {
              strcpy(back->r.msg,"Read error");
              back->status=FTP_STATUS_READY;    // fini
              back->r.statuscode=-1;
            }
          }
          
        }
        
        
        
      }
      
      
    }
    
    _CHECK_HALT_FTP;
    strcpy(back->info,"quit");
    send_line(soc_ctl,"QUIT");    // bye bye
    get_line(soc_ctl,NULL,timeout);
#if HTS_WIN
    closesocket(soc_ctl);
#else
    close(soc_ctl);
#endif
  }
  
  if (back->r.statuscode!=-1) {
    back->r.statuscode=200;
    strcpy(back->r.msg,"OK");
  }
  back->status=FTP_STATUS_READY;    // fini
  return 0;
}



// ouverture d'un port
T_SOC get_datasocket(char* to_send) {
  T_SOC soc = INVALID_SOCKET;
  char h_loc[256+2];
  
  to_send[0]='\0';
  if (gethostname(h_loc,256)==0) {    // host name
    t_hostent* hp_loc;    
    if ( (hp_loc=gethostbyname(h_loc)) ) {  // notre host      
      if ( (soc=socket(AF_INET,SOCK_STREAM,0)) != INVALID_SOCKET) {
        struct sockaddr_in server;
        // effacer structure
        bzero((char *)&server, sizeof(server));
        server.sin_family = AF_INET;
        server.sin_port = htons((unsigned short int) 0);    // demander port qque
        // copie adresse locale
        bcopy(hp_loc->h_addr, (char *)&server.sin_addr, hp_loc->h_length);
        // // NAAN server.sin_addr.s_addr=htonl(INADDR_ANY);
        if ( bind(soc,(struct sockaddr*) &server,sizeof(struct sockaddr)) == 0 ) {
          struct sockaddr_in server2;
          int len;
          len=sizeof(server2);
          // effacer structure
          bzero((char *)&server2, sizeof(server2));
          if (getsockname(soc,(struct sockaddr*) &server2,&len) == 0) {
            // *port=ntohs(server.sin_port);  // rcuprer port
            if (listen(soc,10)>=0) {    // au pif le 10
              unsigned short int a,n1,n2;
              // calculer port
              a  = server2.sin_port;
#ifndef HTS_LITTLE_ENDIAN
              n1 = (a & 0xff);
              n2 = ((a>>8) & 0xff);
#else
              n2 = (a & 0xff);
              n1 = ((a>>8) & 0xff);
#endif
              // calculer adresse
              // pour commande port
              {
                char dots[256];
                char* a;
                char* dot = (char*) inet_ntoa(server2.sin_addr);
                dots[0]='\0';
                //
                strncat(dots,dot,32);
                while( (a=strchr(dots,'.')) ) *a=',';    // virgules!
                sprintf(to_send,"PORT %s,%d,%d",dots,n1,n2);  
              }
              
            } else {
#if HTS_WIN
              closesocket(soc);
#else
              close(soc);
#endif
              soc=INVALID_SOCKET;
            }
            
            
          } else {
#if HTS_WIN
            closesocket(soc);
#else
            close(soc);
#endif
            soc=INVALID_SOCKET;
          }
          
          
        } else {
#if HTS_WIN
          closesocket(soc);
#else
          close(soc);
#endif
          soc=INVALID_SOCKET;
        }
      }
    }
  }
  
  
  return soc;
}

#if FTP_DEBUG
FILE* dd=NULL;
#endif

// routines de rception/mission
// 0 = ERROR
int send_line(T_SOC soc,char* data) {
  char line[1024];
  if (_DEBUG_HEAD) {
    if (ioinfo) {
      fprintf(ioinfo,"---> %s\x0d\x0a",data);
      fflush(ioinfo);
    }
  }
#if FTP_DEBUG
  if (dd == NULL) dd = fopen("toto.txt","w");
  fprintf(dd,"---> %s\x0d\x0a",data); fflush(dd);
  printf("---> %s",data); fflush(stdout);
#endif
  sprintf(line,"%s\x0d\x0a",data);
  if (check_socket_connect(soc) != 1) {
#if FTP_DEBUG
    printf("!SOC WRITE ERROR\n");
#endif
    return 0;    // erreur, plus connect!
  }
#if FTP_DEBUG
  {
    int r = (send(soc,line,strlen(line),0) == (int) strlen(line));
    printf("%s\x0d\x0a",data); fflush(stdout);
    return r;
  }
#else
  return (send(soc,line,strlen(line),0) == (int) strlen(line));
#endif
}

int get_line(T_SOC soc,char* line,int timeout) {
  char data[1024];
  int i,ok;
#if FTP_DEBUG
  if (dd == NULL) dd = fopen("toto.txt","w");
#endif
  
  data[0]='\0';
  i=0; ok=0; data[3]='\0';
  do {
    char b;                        
    
    // vrifier donnes
    switch(wait_socket_receive(soc,timeout)) {
    case -1:   // erreur de lecture
      if (line) strcpy(line,"500 *read error");
      return 0;
      break;
    case 0:
      if (line) sprintf(line,"500 *read timeout (%d)",timeout);
      return 0;
      break;
    }
    
    //HTS_TOTAL_RECV_CHECK(dummy);     // Diminuer au besoin si trop de donnes reues
    switch(recv(soc,&b,1,0)) {
      //case 0: break;    // pas encore --> erreur (on attend)!
    case 1:
      HTS_STAT.HTS_TOTAL_RECV+=1; // compter flux entrant
      if ((b!=10) && (b!=13))
        data[i++]=b;
      break;
    default:
      if (line) strcpy(line,"500 *read error");
      return 0; // error
      break;
    }
    if ( ((b==13) || (b==10)) && (i>0) ){    // CR/LF
      if (data[3]!='-')          // y'en a encore!!
        ok=1;    // sortir
      else {  // suivante
        data[3]='\0';
        i=0;
      }
    }
  } while(!ok);
  data[i++]='\0';
  
  if (_DEBUG_HEAD) {
    if (ioinfo) {
      fprintf(ioinfo,"<--- %s\x0d\x0a",data);
      fflush(ioinfo);
    }
  }
#if FTP_DEBUG
  fprintf(dd,"<--- %s\n",data); fflush(dd);
  printf("<--- %s\n",data);
#endif
  if (line) strcpy(line,data);
  return (strnotempty(data));
}

// sauter NNN
char* linejmp(char* line) {
  if (strlen(line)>4)
    return line+4;
  else
    return line;
}

// test socket:
// 0 : no data
// 1 : data detected
// -1: error
int check_socket(T_SOC soc) {
  fd_set fds,fds_e;           // poll structures
  struct timeval tv;          // structure for select
  FD_ZERO(&fds);
  FD_ZERO(&fds_e); 
  // socket read 
  FD_SET(soc,&fds);           
  // socket error
  FD_SET(soc,&fds_e);
  tv.tv_sec=0;
  tv.tv_usec=0;
  // poll!     
  select(soc + 1,&fds,NULL,&fds_e,&tv);
  if (FD_ISSET(soc,&fds_e)) {  // error detected
    return -1;
  } else if (FD_ISSET(soc,&fds)) {
    return 1;
  }
  return 0;
}
// check if connected
int check_socket_connect(T_SOC soc) {
  fd_set fds,fds_e;           // poll structures
  struct timeval tv;          // structure for select
  FD_ZERO(&fds);
  FD_ZERO(&fds_e); 
  // socket write 
  FD_SET(soc,&fds);           
  // socket error
  FD_SET(soc,&fds_e);
  tv.tv_sec=0;
  tv.tv_usec=0;
  // poll!     
  select(soc + 1,NULL,&fds,&fds_e,&tv);
  if (FD_ISSET(soc,&fds_e)) {  // error detected
    return -1;
  } else if (FD_ISSET(soc,&fds)) {
    return 1;
  }
  return 0;
}
// attendre des donnes
int wait_socket_receive(T_SOC soc,int timeout) {
  // attendre les donnes
  TStamp ltime=time_local();
  int r;
#if FTP_DEBUG
  printf("\x0dWaiting for data "); fflush(stdout);
#endif
  while( (!(r = check_socket(soc))) && ( ((int) ((TStamp) (time_local()-ltime))) < timeout )) {
    Sleep(100);
#if FTP_DEBUG
    printf("."); fflush(stdout);
#endif
  }
#if FTP_DEBUG
  printf("\x0dreturn: %d\x0d",r); fflush(stdout);
#endif
  return r;
}


// cancel reu?
int stop_ftp(lien_back* back) {
  if (back->stop_ftp) {
    strcpy(back->r.msg,"Cancelled by User");
    back->status=FTP_STATUS_READY;    // fini
    back->r.statuscode=-1;
    return 1;
  }
  return 0;
}




